import { HTTPClient } from "./http.js";
import { Logger } from "./logger.js";
import { RetryConfig } from "./retries.js";
/**
 * Contains the list of servers available to the SDK
 */
export declare const ServerList: readonly ["https://api.inkeep.com"];
export type SDKOptions = {
    apiKey?: string | (() => Promise<string>);
    httpClient?: HTTPClient;
    /**
     * Allows overriding the default server used by the SDK
     */
    serverIdx?: number;
    /**
     * Allows overriding the default server URL used by the SDK
     */
    serverURL?: string;
    /**
     * Allows overriding the default retry config used by the SDK
     */
    retryConfig?: RetryConfig;
    timeoutMs?: number;
    debugLogger?: Logger;
};
export declare function serverURLFromOptions(options: SDKOptions): URL | null;
export declare const SDK_METADATA: {
    readonly language: "typescript";
    readonly openapiDocVersion: "0.1.0";
    readonly sdkVersion: "0.8.0";
    readonly genVersion: "2.422.6";
    readonly userAgent: "speakeasy-sdk/typescript 0.8.0 2.422.6 0.1.0 @inkeep/ai-api";
};
//# sourceMappingURL=config.d.ts.map