import * as z from "zod";
import { MessageChunk, MessageChunk$Outbound } from "./messagechunk.js";
/**
 * A server-sent event containing a chunk of the message.
 */
export type ChatResultMessageChunkEvent = {
    event?: "message_chunk" | undefined;
    data: MessageChunk;
};
/** @internal */
export declare const ChatResultMessageChunkEvent$inboundSchema: z.ZodType<ChatResultMessageChunkEvent, z.ZodTypeDef, unknown>;
/** @internal */
export type ChatResultMessageChunkEvent$Outbound = {
    event: "message_chunk";
    data: MessageChunk$Outbound;
};
/** @internal */
export declare const ChatResultMessageChunkEvent$outboundSchema: z.ZodType<ChatResultMessageChunkEvent$Outbound, z.ZodTypeDef, ChatResultMessageChunkEvent>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace ChatResultMessageChunkEvent$ {
    /** @deprecated use `ChatResultMessageChunkEvent$inboundSchema` instead. */
    const inboundSchema: z.ZodType<ChatResultMessageChunkEvent, z.ZodTypeDef, unknown>;
    /** @deprecated use `ChatResultMessageChunkEvent$outboundSchema` instead. */
    const outboundSchema: z.ZodType<ChatResultMessageChunkEvent$Outbound, z.ZodTypeDef, ChatResultMessageChunkEvent>;
    /** @deprecated use `ChatResultMessageChunkEvent$Outbound` instead. */
    type Outbound = ChatResultMessageChunkEvent$Outbound;
}
//# sourceMappingURL=chatresultmessagechunkevent.d.ts.map