import * as z from "zod";
import { RecordsCited, RecordsCited$Outbound } from "./recordscited.js";
/**
 * A server-sent event with information about the records cited in the message.
 */
export type ChatResultRecordsCitedEvent = {
    event?: "records_cited" | undefined;
    data: RecordsCited;
};
/** @internal */
export declare const ChatResultRecordsCitedEvent$inboundSchema: z.ZodType<ChatResultRecordsCitedEvent, z.ZodTypeDef, unknown>;
/** @internal */
export type ChatResultRecordsCitedEvent$Outbound = {
    event: "records_cited";
    data: RecordsCited$Outbound;
};
/** @internal */
export declare const ChatResultRecordsCitedEvent$outboundSchema: z.ZodType<ChatResultRecordsCitedEvent$Outbound, z.ZodTypeDef, ChatResultRecordsCitedEvent>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace ChatResultRecordsCitedEvent$ {
    /** @deprecated use `ChatResultRecordsCitedEvent$inboundSchema` instead. */
    const inboundSchema: z.ZodType<ChatResultRecordsCitedEvent, z.ZodTypeDef, unknown>;
    /** @deprecated use `ChatResultRecordsCitedEvent$outboundSchema` instead. */
    const outboundSchema: z.ZodType<ChatResultRecordsCitedEvent$Outbound, z.ZodTypeDef, ChatResultRecordsCitedEvent>;
    /** @deprecated use `ChatResultRecordsCitedEvent$Outbound` instead. */
    type Outbound = ChatResultRecordsCitedEvent$Outbound;
}
//# sourceMappingURL=chatresultrecordscitedevent.d.ts.map