import * as z from "zod";
import { ChatSessionInput, ChatSessionInput$Outbound } from "./chatsessioninput.js";
export declare enum ChatModeOptions {
    Turbo = "turbo",
    Auto = "auto"
}
export type ChatMode = ChatModeOptions | string;
export type CreateChatSessionWithChatResultInput = {
    integrationId: string;
    chatSession: ChatSessionInput;
    chatMode?: ChatModeOptions | string | undefined;
    stream?: boolean | undefined;
};
/** @internal */
export declare const ChatModeOptions$inboundSchema: z.ZodNativeEnum<typeof ChatModeOptions>;
/** @internal */
export declare const ChatModeOptions$outboundSchema: z.ZodNativeEnum<typeof ChatModeOptions>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace ChatModeOptions$ {
    /** @deprecated use `ChatModeOptions$inboundSchema` instead. */
    const inboundSchema: z.ZodNativeEnum<typeof ChatModeOptions>;
    /** @deprecated use `ChatModeOptions$outboundSchema` instead. */
    const outboundSchema: z.ZodNativeEnum<typeof ChatModeOptions>;
}
/** @internal */
export declare const ChatMode$inboundSchema: z.ZodType<ChatMode, z.ZodTypeDef, unknown>;
/** @internal */
export type ChatMode$Outbound = string | string;
/** @internal */
export declare const ChatMode$outboundSchema: z.ZodType<ChatMode$Outbound, z.ZodTypeDef, ChatMode>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace ChatMode$ {
    /** @deprecated use `ChatMode$inboundSchema` instead. */
    const inboundSchema: z.ZodType<string, z.ZodTypeDef, unknown>;
    /** @deprecated use `ChatMode$outboundSchema` instead. */
    const outboundSchema: z.ZodType<string, z.ZodTypeDef, string>;
    /** @deprecated use `ChatMode$Outbound` instead. */
    type Outbound = ChatMode$Outbound;
}
/** @internal */
export declare const CreateChatSessionWithChatResultInput$inboundSchema: z.ZodType<CreateChatSessionWithChatResultInput, z.ZodTypeDef, unknown>;
/** @internal */
export type CreateChatSessionWithChatResultInput$Outbound = {
    integration_id: string;
    chat_session: ChatSessionInput$Outbound;
    chat_mode?: string | string | undefined;
    stream: boolean;
};
/** @internal */
export declare const CreateChatSessionWithChatResultInput$outboundSchema: z.ZodType<CreateChatSessionWithChatResultInput$Outbound, z.ZodTypeDef, CreateChatSessionWithChatResultInput>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace CreateChatSessionWithChatResultInput$ {
    /** @deprecated use `CreateChatSessionWithChatResultInput$inboundSchema` instead. */
    const inboundSchema: z.ZodType<CreateChatSessionWithChatResultInput, z.ZodTypeDef, unknown>;
    /** @deprecated use `CreateChatSessionWithChatResultInput$outboundSchema` instead. */
    const outboundSchema: z.ZodType<CreateChatSessionWithChatResultInput$Outbound, z.ZodTypeDef, CreateChatSessionWithChatResultInput>;
    /** @deprecated use `CreateChatSessionWithChatResultInput$Outbound` instead. */
    type Outbound = CreateChatSessionWithChatResultInput$Outbound;
}
//# sourceMappingURL=createchatsessionwithchatresultinput.d.ts.map