import * as z from "zod";
export declare enum RecordTypeEnumerated {
    Documentation = "documentation",
    Site = "site",
    DiscoursePost = "discourse_post",
    GithubIssue = "github_issue",
    GithubDiscussion = "github_discussion",
    StackoverflowQuestion = "stackoverflow_question",
    DiscordForumPost = "discord_forum_post",
    DiscordMessage = "discord_message",
    CustomQuestionAnswer = "custom_question_answer"
}
/**
 * The type of record
 */
export type RecordType = RecordTypeEnumerated | string;
/** @internal */
export declare const RecordTypeEnumerated$inboundSchema: z.ZodNativeEnum<typeof RecordTypeEnumerated>;
/** @internal */
export declare const RecordTypeEnumerated$outboundSchema: z.ZodNativeEnum<typeof RecordTypeEnumerated>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace RecordTypeEnumerated$ {
    /** @deprecated use `RecordTypeEnumerated$inboundSchema` instead. */
    const inboundSchema: z.ZodNativeEnum<typeof RecordTypeEnumerated>;
    /** @deprecated use `RecordTypeEnumerated$outboundSchema` instead. */
    const outboundSchema: z.ZodNativeEnum<typeof RecordTypeEnumerated>;
}
/** @internal */
export declare const RecordType$inboundSchema: z.ZodType<RecordType, z.ZodTypeDef, unknown>;
/** @internal */
export type RecordType$Outbound = string | string;
/** @internal */
export declare const RecordType$outboundSchema: z.ZodType<RecordType$Outbound, z.ZodTypeDef, RecordType>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace RecordType$ {
    /** @deprecated use `RecordType$inboundSchema` instead. */
    const inboundSchema: z.ZodType<string, z.ZodTypeDef, unknown>;
    /** @deprecated use `RecordType$outboundSchema` instead. */
    const outboundSchema: z.ZodType<string, z.ZodTypeDef, string>;
    /** @deprecated use `RecordType$Outbound` instead. */
    type Outbound = RecordType$Outbound;
}
//# sourceMappingURL=recordtype.d.ts.map