import * as z from "zod";
import { EventStream } from "../../lib/event-streams.js";
import * as components from "../components/index.js";
export type ContinueRequest = {
    chatSessionId: string;
    continueChatSessionWithChatResultInput: components.ContinueChatSessionWithChatResultInput;
};
export type ContinueResponse = {
    /**
     * HTTP response content type for this operation
     */
    contentType: string;
    /**
     * HTTP response status code for this operation
     */
    statusCode: number;
    /**
     * Raw HTTP response; suitable for custom response parsing
     */
    rawResponse: Response;
    /**
     * Successful Response
     */
    chatResult?: components.ChatResult | undefined;
    /**
     * Successful Response
     */
    chatResultStream?: EventStream<components.ChatResultStream> | undefined;
};
/** @internal */
export declare const ContinueRequest$inboundSchema: z.ZodType<ContinueRequest, z.ZodTypeDef, unknown>;
/** @internal */
export type ContinueRequest$Outbound = {
    chat_session_id: string;
    ContinueChatSessionWithChatResultInput: components.ContinueChatSessionWithChatResultInput$Outbound;
};
/** @internal */
export declare const ContinueRequest$outboundSchema: z.ZodType<ContinueRequest$Outbound, z.ZodTypeDef, ContinueRequest>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace ContinueRequest$ {
    /** @deprecated use `ContinueRequest$inboundSchema` instead. */
    const inboundSchema: z.ZodType<ContinueRequest, z.ZodTypeDef, unknown>;
    /** @deprecated use `ContinueRequest$outboundSchema` instead. */
    const outboundSchema: z.ZodType<ContinueRequest$Outbound, z.ZodTypeDef, ContinueRequest>;
    /** @deprecated use `ContinueRequest$Outbound` instead. */
    type Outbound = ContinueRequest$Outbound;
}
/** @internal */
export declare const ContinueResponse$inboundSchema: z.ZodType<ContinueResponse, z.ZodTypeDef, unknown>;
/** @internal */
export type ContinueResponse$Outbound = {
    ContentType: string;
    StatusCode: number;
    RawResponse: never;
    ChatResult?: components.ChatResult$Outbound | undefined;
    ChatResultStream?: never | undefined;
};
/** @internal */
export declare const ContinueResponse$outboundSchema: z.ZodType<ContinueResponse$Outbound, z.ZodTypeDef, ContinueResponse>;
/**
 * @internal
 * @deprecated This namespace will be removed in future versions. Use schemas and types that are exported directly from this module.
 */
export declare namespace ContinueResponse$ {
    /** @deprecated use `ContinueResponse$inboundSchema` instead. */
    const inboundSchema: z.ZodType<ContinueResponse, z.ZodTypeDef, unknown>;
    /** @deprecated use `ContinueResponse$outboundSchema` instead. */
    const outboundSchema: z.ZodType<ContinueResponse$Outbound, z.ZodTypeDef, ContinueResponse>;
    /** @deprecated use `ContinueResponse$Outbound` instead. */
    type Outbound = ContinueResponse$Outbound;
}
//# sourceMappingURL=continue.d.ts.map