import { ContinueAcceptEnum } from "../funcs/chatSessionContinue.js";
import { CreateAcceptEnum } from "../funcs/chatSessionCreate.js";
import { ClientSDK, RequestOptions } from "../lib/sdks.js";
import * as components from "../models/components/index.js";
import * as operations from "../models/operations/index.js";
export { CreateAcceptEnum } from "../funcs/chatSessionCreate.js";
export { ContinueAcceptEnum } from "../funcs/chatSessionContinue.js";
export declare class ChatSession extends ClientSDK {
    /**
     * Create Chat Session
     */
    create(request: components.CreateChatSessionWithChatResultInput, options?: RequestOptions & {
        acceptHeaderOverride?: CreateAcceptEnum;
    }): Promise<operations.CreateResponse>;
    /**
     * Continue Chat Session
     */
    continue(chatSessionId: string, continueChatSessionWithChatResultInput: components.ContinueChatSessionWithChatResultInput, options?: RequestOptions & {
        acceptHeaderOverride?: ContinueAcceptEnum;
    }): Promise<operations.ContinueResponse>;
}
//# sourceMappingURL=chatsession.d.ts.map